Index: branches/PTSP/HeuristicLab.Problems.PTSP.Views/3.3/PathPTSPTourView.cs
===================================================================
--- branches/PTSP/HeuristicLab.Problems.PTSP.Views/3.3/PathPTSPTourView.cs	(revision 12304)
+++ branches/PTSP/HeuristicLab.Problems.PTSP.Views/3.3/PathPTSPTourView.cs	(revision 12306)
@@ -120,5 +120,5 @@
               }
               for (int i = 0; i < points.Length; i++)
-                graphics.FillRectangle(Brushes.Red, points[i].X - 2, points[i].Y - 2, Convert.ToInt32(probabilities[i] * 10), Convert.ToInt32(probabilities[i] * 10));
+                graphics.FillRectangle(Brushes.Red, points[i].X - 2, points[i].Y - 2, Convert.ToInt32(probabilities[i] * 20), Convert.ToInt32(probabilities[i] * 20));
             }
           } else {
Index: branches/PTSP/HeuristicLab.Problems.PTSP/3.3/AnalyticalPTSP.cs
===================================================================
--- branches/PTSP/HeuristicLab.Problems.PTSP/3.3/AnalyticalPTSP.cs	(revision 12304)
+++ branches/PTSP/HeuristicLab.Problems.PTSP/3.3/AnalyticalPTSP.cs	(revision 12306)
@@ -19,5 +19,5 @@
   [StorableClass]
   public sealed class AnalyticalProbabilisticTravelingSalesmanProblem : ProbabilisticTravelingSalesmanProblem, IStorableContent,
-  IProblemInstanceConsumer<TSPData> {
+  IProblemInstanceConsumer<PTSPData> {
 
     [StorableConstructor]
@@ -137,5 +137,5 @@
     }
 
-    public override void Load(TSPData data) {
+    public override void Load(PTSPData data) {
       base.Load(data);
       foreach (var op in Operators.OfType<PTSPAnalyticalInversionMovePathEvaluator>()) {
Index: branches/PTSP/HeuristicLab.Problems.PTSP/3.3/EstimatedPTSP.cs
===================================================================
--- branches/PTSP/HeuristicLab.Problems.PTSP/3.3/EstimatedPTSP.cs	(revision 12304)
+++ branches/PTSP/HeuristicLab.Problems.PTSP/3.3/EstimatedPTSP.cs	(revision 12306)
@@ -19,7 +19,19 @@
   [StorableClass]
   public sealed class EstimatedProbabilisticTravelingSalesmanProblem : ProbabilisticTravelingSalesmanProblem, IStorableContent,
-  IProblemInstanceConsumer<TSPData> {
+  IProblemInstanceConsumer<PTSPData> {
 
-    private ItemList<ItemList<IntValue>> realizations;
+
+    #region Parameter Properties
+    public IValueParameter<ItemList<ItemList<IntValue>>> RealizationsParameter {
+      get { return (IValueParameter<ItemList<ItemList<IntValue>>>)Parameters["Realizations"]; }
+    }
+    #endregion
+
+    #region Properties
+    public ItemList<ItemList<IntValue>> Realizations {
+      get { return RealizationsParameter.Value; }
+      set { RealizationsParameter.Value = value; }
+    }
+    #endregion
 
     [StorableConstructor]
@@ -38,8 +50,8 @@
       MersenneTwister r = new MersenneTwister();
       double estimatedSum = 0;
-      for (int i = 0; i < realizations.Count; i++) {
+      for (int i = 0; i < Realizations.Count; i++) {
         int singleRealization = -1, firstNode = -1;
-        for (int j = 0; j < realizations[i].Count; j++) {
-          if (realizations[i][p[j]].Value == 1) {
+        for (int j = 0; j < Realizations[i].Count; j++) {
+          if (Realizations[i][p[j]].Value == 1) {
             if (singleRealization != -1) {
               estimatedSum += DistanceMatrix[singleRealization, p[j]];
@@ -54,5 +66,5 @@
         }
       }
-      return estimatedSum / SampleSize.Value;
+      return estimatedSum / RealizationsSize.Value;
     }
 
@@ -90,5 +102,6 @@
 
     public EstimatedProbabilisticTravelingSalesmanProblem() {
-      Parameters.Add(new ValueParameter<IntValue>("SampleSize", "Size of the sample for the estimation-based evaluation"));
+      Parameters.Add(new ValueParameter<IntValue>("RealizationsSize", "Size of the sample for the estimation-based evaluation"));
+      Parameters.Add(new ValueParameter<ItemList<ItemList<IntValue>>>("Realizations", "The concrete..."));
       Operators.Add(new PTSPEstimatedInversionMovePathEvaluator());
       Operators.Add(new PTSPEstimatedInsertionEvaluator());
@@ -134,13 +147,13 @@
     }
 
-    public override void Load(TSPData data) {
+    public override void Load(PTSPData data) {
       base.Load(data);
       // For now uses sample size of 20 but should use Student's t-test
       //Ttest(data.Dimension);
-      SampleSize = new IntValue(100);
+      RealizationsSize = new IntValue(100);
       MersenneTwister r = new MersenneTwister();
       int countOnes = 0;
-      realizations = new ItemList<ItemList<IntValue>>(SampleSize.Value);
-      for (int i = 0; i < SampleSize.Value; i++) {
+      Realizations = new ItemList<ItemList<IntValue>>(RealizationsSize.Value);
+      for (int i = 0; i < RealizationsSize.Value; i++) {
         ItemList<IntValue> newRealization = new ItemList<IntValue>();
         while (countOnes < 4) { //only generate realizations with at least 4 cities visited
@@ -157,15 +170,15 @@
         }
         countOnes = 0;
-        realizations.Add(newRealization);
+        Realizations.Add(newRealization);
       }
 
       foreach (var op in Operators.OfType<PTSPPathMoveEvaluator>()) {
-        op.RealizationsParameter.Value = realizations;
+        op.RealizationsParameter.Value = Realizations;
       }
       foreach (var op in Operators.OfType<PTSPExhaustiveInversionLocalImprovement>()) {
-        op.RealizationsParameter.Value = realizations;
+        op.RealizationsParameter.Value = Realizations;
       }
       foreach (var op in Operators.OfType<PTSP25MoveEvaluator>()) {
-        op.RealizationsParameter.Value = realizations;
+        op.RealizationsParameter.Value = Realizations;
       }
 
Index: branches/PTSP/HeuristicLab.Problems.PTSP/3.3/PTSP.cs
===================================================================
--- branches/PTSP/HeuristicLab.Problems.PTSP/3.3/PTSP.cs	(revision 12304)
+++ branches/PTSP/HeuristicLab.Problems.PTSP/3.3/PTSP.cs	(revision 12306)
@@ -40,5 +40,5 @@
   [StorableClass]
   public abstract class ProbabilisticTravelingSalesmanProblem : SingleObjectiveBasicProblem<PermutationEncoding>, IStorableContent,
-  IProblemInstanceConsumer<TSPData> {
+  IProblemInstanceConsumer<PTSPData> {
     private static readonly int DistanceMatrixSizeLimit = 1000;
 
@@ -59,6 +59,6 @@
       get { return (ValueParameter<DoubleArray>)Parameters["ProbabilityMatrix"]; }
     }
-    public ValueParameter<IntValue> SampleSizeParameter {
-      get { return (ValueParameter<IntValue>)Parameters["SampleSize"]; }
+    public ValueParameter<IntValue> RealizationsSizeParameter {
+      get { return (ValueParameter<IntValue>)Parameters["RealizationsSize"]; }
     }
 
@@ -86,7 +86,7 @@
       set { ProbabilityMatrixParameter.Value = value; }
     }
-    public IntValue SampleSize {
-      get { return SampleSizeParameter.Value; }
-      set { SampleSizeParameter.Value = value; }
+    public IntValue RealizationsSize {
+      get { return RealizationsSizeParameter.Value; }
+      set { RealizationsSizeParameter.Value = value; }
     }
     #endregion
@@ -121,5 +121,5 @@
     }
 
-    public virtual void Load(TSPData data) {
+    public virtual void Load(PTSPData data) {
       if (data.Coordinates == null && data.Distances == null)
         throw new System.IO.InvalidDataException("The given instance specifies neither coordinates nor distances!");
@@ -134,11 +134,5 @@
       Description = data.Description;
 
-      // Get Probabilities of cities using random with seed from hash function on the Name of the instance
-      double[] tempMatrix = new double[data.Dimension];
-      MersenneTwister r = new MersenneTwister((uint)data.Name.GetHashCode());
-      for (int i = 0; i < data.Dimension; i++) {
-        tempMatrix[i] = r.NextDouble();
-      }
-      ProbabilityMatrix = new DoubleArray(tempMatrix);
+      ProbabilityMatrix = new DoubleArray(data.Probabilities);
 
       if (data.BestKnownTour != null) {